package com.flutter_plugin_kyc;

import androidx.annotation.NonNull;

import com.acuant.sampleapp.Constants;

import io.flutter.embedding.engine.plugins.FlutterPlugin;
import io.flutter.plugin.common.MethodCall;
import io.flutter.plugin.common.MethodChannel;
import io.flutter.plugin.common.MethodChannel.MethodCallHandler;
import io.flutter.plugin.common.MethodChannel.Result;

/** FlutterPluginKycPlugin */
public class FlutterPluginKycPlugin implements FlutterPlugin, MethodCallHandler {
  /// The MethodChannel that will the communication between Flutter and native Android
  ///
  /// This local reference serves to register the plugin with the Flutter Engine and unregister it
  /// when the Flutter Engine is detached from the Activity
  private MethodChannel channel;

  @Override
  public void onAttachedToEngine(@NonNull FlutterPluginBinding flutterPluginBinding) {
    //channel = new MethodChannel(flutterPluginBinding.getBinaryMessenger(), "flutter_plugin_kyc");
    channel = new MethodChannel(flutterPluginBinding.getBinaryMessenger(), "ca.couver.kyc/from_flutter_home");

    channel.setMethodCallHandler(this);
  }

  @Override
  public void onMethodCall(@NonNull MethodCall call, @NonNull Result result) {
    if (call.method.equals("getPlatformVersion")) {
      result.success("Android " + android.os.Build.VERSION.RELEASE);
    } else if (call.method.equals("getKyc")){
      MyApplication.kyc(result);
    } else if (call.method.equals("front")){
      //MyApplication.documentType = call.argument(Constants.DOCUMENTTYPE);
      MyApplication.front(result);
    } else if (call.method.equals("back")){
      //MyApplication.documentType = call.argument(Constants.DOCUMENTTYPE);
      MyApplication.back(result);
    } else if (call.method.equals("selfie")){
      MyApplication.selfie(result);
    } else if (call.method.equals("init")){
      MyApplication.init(result);

    } else {

      result.notImplemented();
    }
  }

  @Override
  public void onDetachedFromEngine(@NonNull FlutterPluginBinding binding) {
    channel.setMethodCallHandler(null);
  }
}
