import 'dart:convert';

import 'package:blinkid_flutter/microblink_scanner.dart';
import 'package:blinkid_flutter/overlays/blinkid_overlays.dart';
import 'package:blinkid_flutter/recognizers/blink_id_combined_recognizer.dart';
import 'package:flutter/material.dart';
import 'dart:async';

import 'package:flutter/services.dart';
//import 'package:flutter_plugin_kyc/flutter_plugin_kyc.dart';

void main() {
  runApp(const MyApp());
}

class MyApp extends StatefulWidget {
  const MyApp({Key? key}) : super(key: key);

  @override
  State<MyApp> createState() => _MyAppState();
}

class _MyAppState extends State<MyApp> {
  String _platformVersion = 'Unknown';
  Map _kycResult = {};
  String GSelfie = "selfie";
  String GFront = "front";
  String GBack = "back";

  static const MethodChannel kycChannel = MethodChannel('ca.couver.kyc/from_flutter_home');

  @override
  void initState() {
    super.initState();
    initPlatformState();
    _kycResult[GFront] = "";
    _kycResult[GBack] = "";
    _kycResult[GSelfie] = "";

  }

  // Platform messages are asynchronous, so we initialize in an async method.
  Future<void> initPlatformState() async {
    String platformVersion;
    // Platform messages may fail, so we use a try/catch PlatformException.
    // We also handle the message potentially returning null.
    try {
      //platformVersion =await FlutterPluginKyc.platformVersion ?? 'Unknown platform version';
      platformVersion = await kycChannel.invokeMethod('getPlatformVersion') ?? "Unknown platform version";
    } on PlatformException {
      platformVersion = 'Failed to get platform version.';
    }

    // If the widget was removed from the tree while the asynchronous platform
    // message was in flight, we want to discard the reply rather than calling
    // setState to update our non-existent appearance.
    if (!mounted) return;

    setState(() {
      _platformVersion = platformVersion;
    });
  }

    /*setKycResult(result) {
    Map valueMap = json.decode(result);
    if ((valueMap['backImage'] ?? "").length > 20) {
      FlutterPluginKyc.backBase64 = valueMap['backImage'];
      valueMap['backImage'] = valueMap['backImage'].substring(1, 15) + "...";
    }
    if ((valueMap['frontImage'] ?? "").length > 20) {
      FlutterPluginKyc.frontBase64 = valueMap['frontImage'];
      valueMap['frontImage'] = valueMap['frontImage'].substring(1, 15) + "...";
    }
    if ((valueMap['livePhoto'] ?? "").length > 20) {
      FlutterPluginKyc.selfiBase64 = valueMap['livePhoto'];
      valueMap['livePhoto'] = valueMap['livePhoto'].substring(1, 15) + "...";
    }
    result = json.encode(valueMap);
    setState(() {
      if (result.length > 5000) {
        result = result.substring(0, 5000);
      }
      _kycResult = result;
    });
  }*/

  trulioKYC() async {
    String result = '';
    try {
      //result = await FlutterPluginKyc.kyc ?? "";
      result = await kycChannel.invokeMethod('kyc') ?? "";
      //setKycResult(result);
    } on Exception catch (e) {
      result = e.toString();
    }
  }

  selfi() async {
    String result = '';
    try {
      //result = await FlutterPluginKyc.selfie ?? "";
      result = await kycChannel.invokeMethod('selfie') ?? "";
      _kycResult[GSelfie] = result;
      setState(() {
        if (result.length > 20) {
          result = result.substring(0, 10) + "..." + result.substring(result.length - 10) ;
        }
        _kycResult[GSelfie] = result;

      });
      //setKycResult();
    } on Exception catch (e) {
      result = e.toString();
    }
  }

  front() async {
    String result = '';
    try {
      //FlutterPluginKyc.documentType = "drivingLicense";
      result = await kycChannel.invokeMethod('front') ?? "";
      //result = await FlutterPluginKyc.front ?? "";
      setState(() {
        if (result.length > 20) {
          result = result.substring(0, 10) + "..." + result.substring(result.length - 10) ;
        }
        _kycResult[GFront] = result;

      });

      //setKycResult();
    } on Exception catch (e) {
      result = e.toString();
      setState(() {
        _kycResult[GFront] = result;

      });
    }
  }

  trulioINIT() async {
    String result = '';
    try {
      //await FlutterPluginKyc.init ?? "";
      await kycChannel.invokeMethod('init');

    } on Exception catch (e) {
      result = e.toString();
      _kycResult[GFront] = result;
    }
  }

  back() async {
    String result = '';
    try {
      //FlutterPluginKyc.documentType = "drivingLicense";
      //result = await FlutterPluginKyc.back ?? "";
      result = await kycChannel.invokeMethod('back') ?? "";
      setState(() {
        if (result.length > 20) {
          result = result.substring(0, 10) + "..." + result.substring(result.length - 10) ;
        }
        _kycResult[GBack] = result;

      });
      //setKycResult(result);

      //setKycResult();

    } on Exception catch (e) {
      result = e.toString();
      _kycResult[GFront] = result;
    }
  }

  verify() async {
    String result = '';
    try {
      //FlutterPluginKyc.documentType = "drivingLicense";
      //result = await FlutterPluginKyc.verify ?? "";
      result = await kycChannel.invokeMethod('verify') ?? "";
      //setKycResult(result);
    } on Exception catch (e) {
      result = e.toString();
    }
  }

  Future<void> blink() async {
    //FlutterPluginKyc.frontBase64 ="";
    //FlutterPluginKyc.backBase64 ="";
    //FlutterPluginKyc.selfiBase64 ="";
    //FlutterPluginKyc.firstName = "";
    //FlutterPluginKyc.lastName = "";
    var istest = true;
    if (istest) {
      return;
    }

    String license;
    if (Theme.of(context).platform == TargetPlatform.iOS) {
      license = "";
    } else if (Theme.of(context).platform == TargetPlatform.android) {
      license =
          "sRwAAAAWY29tLmZsdXR0ZXJfcGx1Z2luX2t5Y5fri4BgfjBQWgjzM40vK2W2G4owB0qKGDWODIJmyyAera3bVqxyFsM4ovo01BP0b0e5VYnT3j/gICsL4o99my2GggN3O9EdS49+ZxP3CmshL/GR85SIyymT39p5JCt3ECW3Fuc5shmuHiVFKOYKqGkk2D/26fgOwu+kiFOtlxlLihioz2DQFkQXSiMdK6/meW0HnWtyPW01mShvixMd77E7kuUh/LVfwdbX/VFp3n6K";
    } else {
      license = "";
    }

    var idRecognizer = BlinkIdCombinedRecognizer();
    idRecognizer.returnFullDocumentImage = true;
    idRecognizer.returnFaceImage = true;

    BlinkIdOverlaySettings settings = BlinkIdOverlaySettings();

    var results = await MicroblinkScanner.scanWithCamera(
        RecognizerCollection([idRecognizer]), settings, license);

    if (!mounted) return;

    if (results.isEmpty) return;
    for (var result in results) {
      if (result is BlinkIdCombinedRecognizerResult) {
        if (result.mrzResult?.documentType == MrtdDocumentType.Passport) {
          //_resultString = getPassportResultString(result);
        } else {
          //_resultString = getIdResultString(result);
        }
        getIdResultString(result);
        //FlutterPluginKyc.frontBase64 = result.fullDocumentFrontImage ?? "";
        //FlutterPluginKyc.backBase64 = result.fullDocumentBackImage ?? "";
        return;
      }
    }
  }

  String getIdResultString(BlinkIdCombinedRecognizerResult result) {
    //FlutterPluginKyc.firstName = result.firstName ?? "";
    //FlutterPluginKyc.lastName = result.lastName ?? "";
    return ""; /*buildResult(result.firstName, "First name") +
        buildResult(result.lastName, "Last name") +
        buildResult(result.fullName, "Full name") +
        buildResult(result.localizedName, "Localized name") +
        buildResult(result.additionalNameInformation, "Additional name info") +
        buildResult(result.address, "Address") +
        buildResult(
            result.additionalAddressInformation, "Additional address info") +
        buildResult(result.documentNumber, "Document number") +
        buildResult(
            result.documentAdditionalNumber, "Additional document number") +
        buildResult(result.sex, "Sex") +
        buildResult(result.issuingAuthority, "Issuing authority") +
        buildResult(result.nationality, "Nationality") +
        buildDateResult(result.dateOfBirth, "Date of birth") +
        buildIntResult(result.age, "Age") +
        buildDateResult(result.dateOfIssue, "Date of issue") +
        buildDateResult(result.dateOfExpiry, "Date of expiry") +
        buildResult(result.dateOfExpiryPermanent.toString(),
            "Date of expiry permanent") +
        buildResult(result.maritalStatus, "Martial status") +
        buildResult(result.personalIdNumber, "Personal Id Number") +
        buildResult(result.profession, "Profession") +
        buildResult(result.race, "Race") +
        buildResult(result.religion, "Religion") +
        buildResult(result.residentialStatus, "Residential Status") +
        buildDriverLicenceResult(result.driverLicenseDetailedInfo);*/
  }

  String buildResult(String? result, String propertyName) {
    if (result == null || result.isEmpty) {
      return "";
    }

    return propertyName + ": " + result + "\n";
  }

  String buildDateResult(Date? result, String propertyName) {
    if (result == null || result.year == 0) {
      return "";
    }

    return buildResult(
        "${result.day}.${result.month}.${result.year}", propertyName);
  }

  String buildIntResult(int? result, String propertyName) {
    if (result == null || result < 0) {
      return "";
    }

    return buildResult(result.toString(), propertyName);
  }

  String buildDriverLicenceResult(DriverLicenseDetailedInfo? result) {
    if (result == null) {
      return "";
    }

    return buildResult(result.restrictions, "Restrictions") +
        buildResult(result.endorsements, "Endorsements") +
        buildResult(result.vehicleClass, "Vehicle class") +
        buildResult(result.conditions, "Conditions");
  }

  String getPassportResultString(BlinkIdCombinedRecognizerResult? result) {
    if (result == null) {
      return "";
    }

    var dateOfBirth = "";
    if (result.mrzResult?.dateOfBirth != null) {
      dateOfBirth = "Date of birth: ${result.mrzResult!.dateOfBirth?.day}."
          "${result.mrzResult!.dateOfBirth?.month}."
          "${result.mrzResult!.dateOfBirth?.year}\n";
    }

    var dateOfExpiry = "";
    if (result.mrzResult?.dateOfExpiry != null) {
      dateOfExpiry = "Date of expiry: ${result.mrzResult?.dateOfExpiry?.day}."
          "${result.mrzResult?.dateOfExpiry?.month}."
          "${result.mrzResult?.dateOfExpiry?.year}\n";
    }

    return "First name: ${result.mrzResult?.secondaryId}\n"
        "Last name: ${result.mrzResult?.primaryId}\n"
        "Document number: ${result.mrzResult?.documentNumber}\n"
        "Sex: ${result.mrzResult?.gender}\n"
        "$dateOfBirth"
        "$dateOfExpiry";
  }

  @override
  Widget build(BuildContext context) {
    return MaterialApp(
      home: Scaffold(
        appBar: AppBar(
          title: const Text('Plugin example app'),
        ),
        body: Center(
          child: Column(
            children: [
              Text('Running on: $_platformVersion\n'),
              ElevatedButton(onPressed: trulioINIT, child: const Text('INIT')),
              //ElevatedButton(onPressed: trulioKYC, child: const Text('KYC')),
              ElevatedButton(
                  onPressed: front, child: const Text('Trulio Front')),
              ElevatedButton(onPressed: back, child: const Text('Trulio Back')),
              ElevatedButton(
                  onPressed: selfi, child: const Text('Trulio Selfi')),
              //ElevatedButton(onPressed: blink, child: const Text('Blink Front and back')),
              //ElevatedButton(onPressed: verify, child: const Text('Trulio Verify')),
              Expanded(
                  child:
                  SingleChildScrollView(
                      child: Column(
                          children: [
                            Text("Front: "+ _kycResult[GFront] ),
                            Text("Back: "+_kycResult[GBack]),
                            Text("Selfie: "+_kycResult[GSelfie]),

                          ]
                      )
                  )
              )
            ],
          ),
        ),
      ),
    );
  }
}
